import MeCab
import pandas as pd


# 結果表スキーマ取得関数
def schema_func(input_schema):
    # 形態素解析の結果を追加
    return input_schema + ["品詞 VARCHAR", "単語 VARCHAR", "基本形 VARCHAR"] 

# 処理関数
def proc_func(context, input, *args):
    keitaisoStyle = "-Owakati" #"mecabrc" "-Ochasen" "-Owakati"
    mecab = MeCab.Tagger(keitaisoStyle)
    targetKey = args[0]

    df_bf = pd.DataFrame(columns = input.columns)

    addColumnName = ["品詞", "単語", "基本形"]
    extWordClass = ["名詞", "動詞","形容詞"]

    dropColumnName = []
    df_bf = df_bf.drop(columns=dropColumnName)

    for cname in addColumnName:
        df_bf[cname] = ""

    for recordIdx, requestSentence in enumerate(input[targetKey]):
        mecab.parse('')
        node = mecab.parseToNode(str(requestSentence))
        # print(recordIdx, mecab.parse(requestSentence).split(" "))

        while node:
            if(node.surface==""):
                node = node.next
                continue

            keitaisoList = node.feature.split(",")
            # print(keitaisoList)
            if(keitaisoList[0] in extWordClass):
                # print(node.surface, keitaisoList)
                tmp = [keitaisoList[0], node.surface, keitaisoList[6] if len(keitaisoList)>=8 else node.surface]
                add_df = pd.DataFrame([input.iloc[recordIdx].to_list() + tmp], columns = df_bf.columns)
                df_bf = pd.concat([df_bf, add_df], axis=0)
            node = node.next
    
    return df_bf